#!/usr/bin/env python
#coding=utf-8
import pygtk
pygtk.require('2.0')
import gtk.glade
import pango
import os
import cPickle
from system import *

class FormatList():
    def __init__(self):
        self.list={}
        self.file=preset
        if os.path.isfile(self.file):
            f = file(preset)
            self.list = cPickle.load(f)
            f.close
        for key in self.list:
            self.list[key]=initfmtdata(self.list[key])
    def dump(self):
        f = file(self.file, 'w')
        cPickle.dump(self.list, f)
        f.close()
    def save(self,name,data):
        self.list[name]=dict(data)
        self.dump()
    def delete(self,name):
        del self.list[name]
        self.dump()
    def load(self,name):
        fmtlist.data=dict(initfmtdata(self.list[name]))


class LavcAudioopt:
    def __init__(self):
        xml = self.xml = gtk.glade.XML('./ui/ui.glade',"LavcAudioWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('LavcAudioWin')
        self.sabit= xml.get_widget('SABit')
    def changerabit(self,a=None,b=None,c=None):
        fmtinfo.data["audiooptions"]["abitrate"]=int(self.sabit.get_value())
    def refresh(self):
        self.sabit.set_value(fmtinfo.data["audiooptions"]["abitrate"])
    def setup(self):
        self.refresh()
        self.win.show()
    def close(self,a=None,b=None,c=None):
        self.win.hide()
        return True
    def getcmd(self):
        return ":abitrate="+str(fmtinfo.data["audiooptions"]["abitrate"])
    def init(self):
        return {"abitrate":224}

class LavcVideoopt:
    def __init__(self):
        xml = self.xml = gtk.glade.XML('./ui/ui.glade',"LavcVideoWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('LavcVideoWin')
        self.cvbr= xml.get_widget('CVBR')
        self.vbr= xml.get_widget('VBR')
        self.fixed= xml.get_widget('Fixed')
        self.svbr= xml.get_widget('SVBR')
        self.svqmin= xml.get_widget('SVqmin')
        self.svqmax= xml.get_widget('SVqmax')
        self.svqscale= xml.get_widget('SVqscale')
    def changevbr(self,a=None,b=None,c=None):
        fmtinfo.data["videooptions"]["vbitrate"]=int(self.svbr.get_value())
    def changevqmax(self,a=None,b=None,c=None):
        fmtinfo.data["videooptions"]["vqmax"]=int(self.svqmax.get_value())
    def changevqmin(self,a=None,b=None,c=None):
        fmtinfo.data["videooptions"]["vqmin"]=int(self.svqmin.get_value())
    def changevqscale(self,a=None,b=None,c=None):
        fmtinfo.data["videooptions"]["vqscale"]=int(self.svqscale.get_value())
    def togglevbr(self,a=None,b=None,c=None):
        fmtinfo.data["videooptions"]["vbr"]=self.cvbr.get_active()
        self.refresh()
    def refresh(self):
        self.svbr.set_value(fmtinfo.data["videooptions"]["vbitrate"])
        self.svqmin.set_value(fmtinfo.data["videooptions"]["vqmin"])
        self.svqmax.set_value(fmtinfo.data["videooptions"]["vqmax"])
        self.svqscale.set_value(fmtinfo.data["videooptions"]["vqscale"])
        self.cvbr.set_active(fmtinfo.data["videooptions"]["vbr"])
        if fmtinfo.data["videooptions"]["vbr"]:
            self.vbr.show()
            self.fixed.hide()
        else:
            self.vbr.hide()
            self.fixed.show()
    def setup(self):
        self.refresh()
        self.win.show()
    def close(self,a=None,b=None,c=None):
        self.win.hide()
        return True
    def getcmd(self):
        if fmtinfo.data["videooptions"]["vbr"]:
            cmd=":vbitrate="+str(fmtinfo.data["videooptions"]["vbitrate"])+":vqmax="+str(fmtinfo.data["videooptions"]["vqmax"])+":vqmin="+str(fmtinfo.data["videooptions"]["vqmin"])
        else:
            cmd=":vqscale="+str(fmtinfo.data["videooptions"]["vqscale"])
        return cmd
    def init(self):
        return {"vbr":True,"vbitrate":800,"vqmin":2,"vqmax":31,"vqscale":2}

class CFmtList(object):
    def __init__(self):
        self.clear()
    def clear(self):
        self.data={}
    def add(self,data):
        for key in data:
            self.data[key]=data[key]


def initfmtdata(data={}):
    fmtdata={"Container":"mp4",
            "videocodec":"mpeg4",
            "videooptions":vo["lavcv"].init(),
            "audiocodec":"libfaac",
            "audiooptions":ao["lavc"].init(),
            "resample":False,
            "srate":"44100",
            "changesize":False,
            "dsize":True,
            "width":"320",
            "height":"240",
            "fps":"25",
            "starttime":{"enable":False,
                "value":"0"},
            "endtime":{"enable":False,
                "value":"0"},
            "videofilter":{},
            "misc":{},
            "other":""
        }
    if data.has_key("Container"):
        if ContainerList.data.has_key(data["Container"]):
            fmtdata["Container"]=data["Container"]
    if data.has_key("videocodec"):
        if VideoList.data.has_key(data["videocodec"]):
            fmtdata["videocodec"]=data["videocodec"]
    if data.has_key("audiocodec"):
        if AudioList.data.has_key(data["videocodec"]):
            fmtdata["audiocodec"]=data["audiocodec"]
    if data.has_key("videooptions"):
        fmtdata["videooptions"]=data["videooptions"]
    if data.has_key("fps"):
        fmtdata["fps"]=data["fps"]
    if data.has_key("audiooptions"):
        fmtdata["audiooptions"]=data["audiooptions"]
    if data.has_key("changesize") :
        fmtdata["changesize"]=data["changesize"]
    if data.has_key("srate") :
        fmtdata["srate"]=data["srate"]
    if data.has_key("resample") :
        fmtdata["resample"]=data["resample"]
    if data.has_key("dsize") :
        fmtdata["dsize"]=data["dsize"]
    if data.has_key("width") :
        fmtdata["width"]=data["width"]
    if data.has_key("height") :
        fmtdata["height"]=data["height"]
    if data.has_key("starttime"):
        fmtdata["starttime"]=data["starttime"]
    if data.has_key("endtime"):
        fmtdata["endtime"]=data["endtime"]
    if data.has_key("videofilter"):
        fmtdata["videofilter"]=data["videofilter"]
    if data.has_key("misc"):
        fmtdata["misc"]=data["misc"]
    if data.has_key("other"):
        fmtdata["other"]=data["other"]
    return fmtdata


from formatlist import *

class FmtInfo:
    def __init__(self):
        self.data=initfmtdata()
        self.video=CVideo(self.data)
        self.audio=CAudio(self.data)
        self.container=CContainer(self.data)
        self.vf=VF()
        self.fps=FPS(self.data)
        self.misc=MISC()
    def setdata(self,data):
        self.data=data
    def getdata(self):
        return self.data
    def getcmd(self):
        return  self.container.getcmd()+" "+self.video.getcmd()+" "+self.audio.getcmd()+ " " +self.vf.getcmd()+ " "+self.fps.getcmd() +" "+self.misc.getcmd()+" "+preferences["mencoder"]["parameters"]+" "+fmtinfo.data["other"]




class VF:
    def __init__(self):
        pass
    def getcmd(self):
        cmd=""
        if fmtinfo.data["changesize"]:
            if fmtinfo.data["dsize"]:
                cmd+="dsize="+fmtinfo.data["width"]+":"+fmtinfo.data["height"]+":0,scale=0:0,expand="+fmtinfo.data["width"]+":"+fmtinfo.data["height"]
            else:
                cmd+="scale="+fmtinfo.data["width"]+":"+fmtinfo.data["height"]
        if fmtinfo.data["fps"]!="":
            if cmd!="":
                cmd+=","
            cmd+="harddup"
        if cmd !="":
            cmd="-vf "+cmd
        return cmd
    
class MISC:
    def __init__(self):
        pass
    def getcmd(self):
        cmd=""
        if fmtinfo.data["starttime"]["enable"]:
            cmd+=" -ss "+fmtinfo.data["starttime"]["value"]
        if fmtinfo.data["endtime"]["enable"]:
            cmd+=" -endpos "+fmtinfo.data["endtime"]["value"]
        return cmd
class CVideo(object):
    def __init__(self,data):
        self.data=data
    def setfmt(self,id,fmtcmd):
        self.id=id
        self.fmtcmd=fmtcmd
    def getcmd(self):
        cmd=VideoList.data[fmtinfo.data["videocodec"]]["cmd"]
        if vo.has_key(VideoList.data[fmtinfo.data["videocodec"]]["type"]):
            vset=vo[VideoList.data[fmtinfo.data["videocodec"]]["type"]]
            cmd=cmd+vset.getcmd()
        return cmd



class CAudio:
    def __init__(self,data):
        self.data=data
    def getcmd(self):
        cmd=AudioList.data[fmtinfo.data["audiocodec"]]["cmd"]
        if ao.has_key(AudioList.data[fmtinfo.data["audiocodec"]]["type"]):
            aset=ao[AudioList.data[fmtinfo.data["audiocodec"]]["type"]]
            cmd=cmd+aset.getcmd()
        if fmtinfo.data["resample"]:
            cmd+=" -af lavcresample="+fmtinfo.data["srate"]+" -srate "+fmtinfo.data["srate"]
        return cmd


class CContainer:
    def __init__(self,data):
        self.data=data
    def getcmd(self):
        return ContainerList.data[fmtinfo.data["Container"]]["cmd"]
    
class FPS:
    def __init__(self,data):
        self.data=data
    def getcmd(self):
        if fmtinfo.data["fps"]=="":
            return ""
        else:
            return "-ofps "+fmtinfo.data["fps"]

fmtinfo=FmtInfo()
formatlist=FormatList()





