#!/usr/bin/env python
#coding=utf-8
from classfmt import *
ContainerList=CFmtList()
VideoList=CFmtList()
AudioList=CFmtList()

subtitlelist=["srt","ssa","sub"]


ContainerList.add({
"ogg":{"name":"ogg(lavf)    Ogg format" , "type":"ogg" , "cmd":"-of lavf -lavfopts format=ogg"} ,
"dv":{"name": _ ("dv(lavf)     DV video format"),"type":"dv","cmd":"-of lavf -lavfopts format=dv"},
"flv":{"name":_("flv(lavf)    flv format"),"type":"flv","cmd":"-of lavf -lavfopts format=flv"},
"mp4":{"name":_("mp4(lavf)    mp4 format"),"type":"mp4","cmd":"-of lavf -lavfopts format=mp4 -lavcopts aglobal=1:vglobal=1"},
"avi":{"name":_("avi(lavf)    avi format"),"type":"avi","cmd":"-of lavf -lavfopts format=avi"},
"mov":{"name":_("mov(lavf)    mov format"),"type":"mov","cmd":"-of lavf -lavfopts format=mov -lavcopts aglobal=1:vglobal=1"},
"swf":{"name":_("swf(lavf)    flash format"),"type":"swf","cmd":"-of lavf -lavfopts format=swf"},
"rm":{"name":_("rm(lavf)    rm format"),"type":"rm","cmd":"-of lavf -lavfopts format=rm"},
"gif":{"name":_("gif(lavf)    GIF Animation"),"type":"gif","cmd":"-of lavf -lavfopts format=gif"},
"rawaudio":{"name":_("Rawaudio"),"type":"","cmd":"-of rawaudio"}
})


VideoList.add({
"flv":{"name":_("flv(lavc)    flv video") , "type":"lavcv" , "cmd":"-ovc lavc -lavcopts vcodec=h261"} ,
"copy":{"name":_("copy") , "type":"copy" , "cmd":"-ovc copy"} ,
"h261":{"name":_("h261(lavf)     H261 video format"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=h261"},
"h263":{"name":_("h263(lavf)     H263 video format"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=h263"},
"h264":{"name":_("x264(lavf)     H264 video format"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=libx264"},
"libxvid":{"name":_("x264(lavf)     Xvid MPEG-4 Part 2 (ASP)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=libxvid"},
"mpeg1video":{"name":_("mpeg1video(lavf)     MPEG-1 video"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=mpeg1video"},
"mpeg2video":{"name":_("mpeg2video(lavf)     MPEG-2 video"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=mpeg2video"},
"mpeg4":{"name":_("MPEG-4 (DivX 4/5)(lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=mpeg4"},
"msmpeg4":{"name":_("MS MPEG-4 (DivX 3)(lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=msmpeg4"},
"msmpeg4v2":{"name":_("MS MPEG-4  v2 (lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=msmpeg4v2"},
"wmv1":{"name":_("Windows Media Video, version 1 (AKA WMV7)(lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=wmv1"},
"wmv2":{"name":_("Windows Media Video, version 2 (AKA WMV8)(lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=wmv2"},
"rv10":{"name":_("an old RealVideo codec(lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=rv10"},
"dvvideo":{"name":_("Sony Digital Video(lavf)"),"type":"lavcv","cmd":"-ovc lavc -lavcopts vcodec=dvvideo"},
"libtheora":{"name":_("theora(lavc)    theora codec,Ogg video") , "type":"lavcv" , "cmd":"-ovc lavc -lavcopts vcodec=libtheora"} 
})




AudioList.add({
"mp3":{"name":_("mp3(lavc)    mp3 audio(LAME)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=libmp3lame"} ,
"ac3":{"name":_("Dolby Digital (AC-3)(lavc)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=ac3"} ,
"flac":{"name":_("Free Lossless Audio Codec (FLAC)(lavc)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=flac"} ,
"libamr_wb":{"name":_("3GPP Adaptive Multi-Rate (AMR) wide-band(lavc)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=libamr_wb"} ,
"libamr_nb":{"name":_("3GPP Adaptive Multi-Rate (AMR) narrow-band(lavc)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=libamr_nb"} ,
"libfaac":{"name":_("Advanced Audio Coding (AAC) - using FAAC(lavc)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=libfaac"} ,
"mp2":{"name":_("mp2(lavc) MPEG-1 audio layer 2") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=mp2"} ,
"wmav1":{"name":_("wma1(lavc) Windows Media Audio v1") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=wmav1"} ,
"wmav2":{"name":_("wma2(lavc )Windows Media Audio v2") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=wmav2"} ,
"vorbis":{"name":_("vorbis(lavc)    vorbis audio,Ogg audio(lavc)") , "type":"lavc" , "cmd":"-oac lavc -lavcopts acodec=vorbis"}

})


vo={"lavcv":LavcVideoopt()}
ao={"lavc":LavcAudioopt()}

