#!/usr/bin/env python
#coding=utf-8
import os
import gettext
import locale
import sys
import shutil
global APP_NAME,local_path,ui_path,profile,app_path,profile_path,preferences
import ConfigParser
import signal
import subprocess

if os.name=="nt":
    import ctypes
APP_NAME = "pyvideoconv"
app_path=os.path.realpath(os.path.dirname(sys.argv[0]))+os.sep
local_path = os.path.realpath(os.path.dirname(sys.argv[0]))+os.sep+"locale"+os.sep
gettext.install(APP_NAME,local_path)
import urllib

preferences={
    "subtitle":{
        "usesub":"True",
        "charset":_("charset_cp936")[8:],
        "usefont":"False",
        "font":"system"
        },
    "mencoder":{
        "mencodercmd":"mencoder",
        "parameters":""
        },
    "general":{
        "lastoutputpath":os.path.expanduser("~")+os.sep
        }
}

localstr=_
ui_path= os.path.realpath(os.path.dirname(sys.argv[0]))+os.sep+"ui"+os.sep

mencoder_path=os.path.realpath(os.path.dirname(sys.argv[0]))+os.sep+"mencoder"+os.sep
if not os.path.exists(mencoder_path):
    mencoder_path=""
profile_path=os.path.realpath(os.path.dirname(sys.argv[0]))+os.sep
if not os.access(profile_path,os.R_OK or os.W_OK):
    profile_path=os.path.expanduser("~")+os.sep+".pyvideoconv"+os.sep
if not os.path.exists(profile_path):
    os.mkdir(profile_path)
preset=profile_path+"preset"
if not os.path.exists(preset):
    if os.path.exists(app_path+"_preset"):
        shutil.copyfile(app_path+"_preset",preset)
config=ConfigParser.ConfigParser()
profile=profile_path+"config"
if  os.path.exists(profile):
    try: 
        config.read(profile)
        for key in preferences:
            if config.has_section(key):
                for key2 in preferences[key]:
                    if config.has_option(key,key2):
                        preferences[key][key2]=config.get(key,key2)
    except:
        pass
config=None

def saveconfig(data):
    config=ConfigParser.ConfigParser()
    f=open(profile,"w")
    for key in data:
        config.add_section(key)
        for key2 in preferences[key]:
            config.set(key,key2,preferences[key][key2])
    config.write(f)
    f.close()
    config=None
def uritofilename(uri):
    path = urllib.url2pathname(uri)
    path = path.strip('\r\n\x00')
    return path
def filecode(str):
    return str.encode(sys.getfilesystemencoding())

def pkill(process):
    if os.name=="nt":
        ctypes.windll.kernel32.TerminateProcess(int(process._handle), -1)  
    else:
        os.kill(process.pid,signal.SIGKILL)

def runmencoder(cmd):
    if os.name=="nt":
        return subprocess.Popen(cmd,stdout=subprocess.PIPE,stderr=subprocess.PIPE,bufsize=1,universal_newlines=True,creationflags=0x8000000)
    return subprocess.Popen(cmd,stdout=subprocess.PIPE,stderr=subprocess.PIPE,bufsize=1,universal_newlines=True)

