#!/usr/bin/env python
#coding=utf-8
import pygtk
pygtk.require('2.0')
import gtk.glade
import pango
import gobject
from system import *
from commondialog import *
gtk.glade.bindtextdomain(APP_NAME, local_path)
from classfmt import *
from formatlist import *

ICON=gtk.gdk.pixbuf_new_from_file(ui_path+"pyvideoconv.png")
import os
import sys
import string
import thread
import re
fmt_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
customfmtiter=fmt_store.append([_("CustomFormat"),"CustomFormat"])
for key in formatlist.list:
    fmt_store.append([_(key),key])


class MainWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"MainWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('MainWin')
        self.win.set_icon(ICON)
        CR=self.CR=gtk.CellRendererText()
        self.cfmt= xml.get_widget('CFmt')
        self.cfmt.set_model(fmt_store)
        self.cfmt.pack_start(self.CR,False)
        self.cfmt.add_attribute(self.CR, "text",0)
        self.tcommand= xml.get_widget('TCommand')
        self.cvideochangesize= xml.get_widget('CVideoChangeSize')
        self.svideowidth= xml.get_widget("SVideoWidth")
        self.svideoheight= xml.get_widget("SVideoHeight")
        self.lwidth= xml.get_widget("LWidth")
        self.lheight= xml.get_widget("LHeight")
        self.einfile= xml.get_widget("EInFile")
        self.einfile.connect('drag_data_received', self.ondrag)
        self.einfile.drag_dest_set( gtk.DEST_DEFAULT_MOTION |gtk.DEST_DEFAULT_HIGHLIGHT | gtk.DEST_DEFAULT_DROP,[ ( 'text/uri-list', 0, 80 ) ], gtk.gdk.ACTION_COPY)
        self.eoutfile= xml.get_widget("EOutFile")
        self.foutpath= xml.get_widget("FOutPath")
        if os.path.exists(preferences["general"]["lastoutputpath"].strip()):
            self.foutpath.set_filename(preferences["general"]["lastoutputpath"].strip().decode(sys.getfilesystemencoding()))
        self.hchangesize= xml.get_widget("HChangeSize")
        self.cdsize= xml.get_widget("CDSize")
        self.cstarttime= xml.get_widget('CStartTime')
        self.cendtime= xml.get_widget('CEndTime')
        self.estarttime= xml.get_widget('EStartTime')
        self.eendtime= xml.get_widget('EEndTime')
        self.csetasample= xml.get_widget('CSetASample')
        self.esrate= xml.get_widget('ESRate')
    def encode(self,a=None,b=None,c=None):
        if self.einfile.get_text()=="":
            msgbox("ERROR:","ERROR:","No inputfile choosen.")
        else:
            preferences["general"]["lastoutputpath"]=filecode(self.foutpath.get_filename())
            saveconfig(preferences)
            outputwin.run(self.einfile.get_text(),self.foutpath.get_filename(),self.eoutfile.get_text(),fmtinfo.getcmd())
    def ondrag(self,widget, context, x, y, selection, target_type, timestamp):
        files=[]
        uri = selection.data.strip()
        if uri=="" or uri==None:
            return
        uri_splitted = uri.split()
        for uri in uri_splitted:
            files.append(uritofilename(uri))
        self.einfile.set_text(" ".join(['\"%s\"' % k.replace('"','\\"') for k in files]))
        context.finish(True,False) 
        return True
    def preferences(self,a=None,b=None,c=None):
        preferenceswin.go()
    def close(self,a=None,b=None,c=None):
        gtk.main_quit()
    def about(self,a=None,b=None,c=None):
        aboutwin.win.run()
        aboutwin.win.hide()
    def on_CFmt_changed(self,a="",b="",c=""):
        if self.cfmt.get_active_iter()==None:
            return
        if fmt_store.get_value(self.cfmt.get_active_iter(),1)=="CustomFormat":
            setwin.show()
        else:
            fmtinfo.data=dict(formatlist.list[fmt_store.get_value(self.cfmt.get_active_iter(),1)])
            self.refresh()
    def on_menuitem3_activate(self,a=None,b=None,c=None):
        setwin.show()
    def refresh(self):
        self.tcommand.get_buffer().set_text("mencoder "+fmtinfo.getcmd())
        self.cvideochangesize.set_active(fmtinfo.data["changesize"])
        if fmtinfo.data["changesize"]:
            self.hchangesize.show()
        else:
            self.hchangesize.hide()
        self.cstarttime.set_active(fmtinfo.data["starttime"]["enable"])
        self.estarttime.set_text(fmtinfo.data["starttime"]["value"])
        if fmtinfo.data["starttime"]["enable"]:
            self.estarttime.show()
        else:
            self.estarttime.hide()
        self.cendtime.set_active(fmtinfo.data["endtime"]["enable"])
        self.eendtime.set_text(fmtinfo.data["endtime"]["value"])
        if fmtinfo.data["endtime"]["enable"]:
            self.eendtime.show()
        else:
            self.eendtime.hide()
        self.csetasample.set_active(fmtinfo.data["resample"])
        self.esrate.set_text(fmtinfo.data["srate"])
        if fmtinfo.data["resample"]:
            self.esrate.show()
        else:
            self.esrate.hide()
        self.cdsize.set_active(fmtinfo.data["dsize"])
        self.svideowidth.set_text(fmtinfo.data["width"])
        self.svideoheight.set_text(fmtinfo.data["height"])
    def sizechange(self,a="",b="",c=""):
        fmtinfo.data["changesize"]=self.cvideochangesize.get_active()
        self.refresh()
    def widthchange(self,a="",b="",c=""):
        fmtinfo.data["width"]=str(int(self.svideowidth.get_value()))
        self.refresh()
    def heightchange(self,a="",b="",c=""):
        fmtinfo.data["height"]=str(int(self.svideoheight.get_value()))
        self.refresh()
    def on_BBrowseInFile_clicked(self,a="",b="",c=""):
        file=open_file_dialog()
        if file:
            self.einfile.set_text(file)
    def on_CDSize_toggled(self,a=None,b=None,c=None):
        fmtinfo.data["dsize"]=self.cdsize.get_active()
        self.refresh()
    def on_EStartTime_changed(self,a=None,b=None,c=None):
        fmtinfo.data["starttime"]["value"]=self.estarttime.get_text()
        self.refresh()
    def on_EEndTime_changed(self,a=None,b=None,c=None):
        fmtinfo.data["endtime"]["value"]=self.eendtime.get_text()
        self.refresh()
    def on_CStartTime_toggled(self,a=None,b=None,c=None):
        fmtinfo.data["starttime"]["enable"]=self.cstarttime.get_active()
        self.refresh()
    def on_CEndTime_toggled(self,a=None,b=None,c=None):
        fmtinfo.data["endtime"]["enable"]=self.cendtime.get_active()
        self.refresh()
    def setasample(self,a=None,b=None,c=None):
        fmtinfo.data["resample"]=self.csetasample.get_active()
        self.refresh()
    def srate(self,a=None,b=None,c=None):
        fmtinfo.data["srate"]=self.esrate.get_text()
        self.refresh()
#read formatlist
fmtset_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
confmt_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
audiocodec_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
videocodec_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
for key in ContainerList.data:
    ContainerList.data[key]["iter"]=confmt_store.append([ContainerList.data[key]["name"],key])
for key in VideoList.data:
    VideoList.data[key]["iter"]=videocodec_store.append([VideoList.data[key]["name"],key])
for key in AudioList.data:
    AudioList.data[key]["iter"]=audiocodec_store.append([AudioList.data[key]["name"],key])

class SetWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"SetWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('SetWin')
        self.econcmd= xml.get_widget('EConCmd')
        self.evideocmd= xml.get_widget('EVideoCmd')
        self.eaudiocmd= xml.get_widget('EAudioCmd')
        self.efpscmd= xml.get_widget('EFpsCmd')
        self.efps= xml.get_widget('EFps')
        self.cfmtset= xml.get_widget('CFmtSet')
        self.ecfmtset= xml.get_widget('ECFmtSet')
        self.eothercmd= xml.get_widget('EOtherCmd')
        self.win.set_icon(ICON)
        #init combox
        self.cconfmt= xml.get_widget('CConFmt')
        self.cconfmt.set_model(confmt_store)
        self.caudiocodec= xml.get_widget('CAudioCodec')
        self.caudiocodec.set_model(audiocodec_store)
        self.cvideocodec= xml.get_widget('CVideoCodec')
        self.cvideocodec.set_model(videocodec_store)
        CR=self.CR=gtk.CellRendererText()
        self.cconfmt.pack_start(self.CR,False) 
        self.caudiocodec.pack_start(self.CR,False)
        self.cvideocodec.pack_start(self.CR,False)
        self.cconfmt.add_attribute(self.CR, "text",0)
        self.caudiocodec.add_attribute(self.CR, "text",0)
        self.cvideocodec.add_attribute(self.CR, "text",0)
        self.cfmtset.set_model(fmtset_store)
        self.cfmtset.clear_attributes
        self.cfmtset.pack_start(self.CR,False)
        self.cfmtset.add_attribute(self.CR, "text",0)
    def show(self):
        self.refresh()
        self.fmtset_refresh()
        self.win.show()
    def refresh(self):
        self.cconfmt.set_active_iter(ContainerList.data[fmtinfo.data["Container"]]["iter"])
        self.caudiocodec.set_active_iter(AudioList.data[fmtinfo.data["audiocodec"]]["iter"])
        self.cvideocodec.set_active_iter(VideoList.data[fmtinfo.data["videocodec"]]["iter"])
        self.efps.set_text(fmtinfo.data["fps"])
        self.efpscmd.set_text(fmtinfo.fps.getcmd())
        self.econcmd.set_text(fmtinfo.container.getcmd())
        self.eaudiocmd.set_text(fmtinfo.audio.getcmd())
        self.evideocmd.set_text(fmtinfo.video.getcmd())
        self.eothercmd.set_text(fmtinfo.data["other"])
    def fmtset_refresh(self,name=None):
        fmtset_store.clear()
        fmtsetdict={}
        for key in formatlist.list:
            fmtsetdict[key]=fmtset_store.append([_(key+" format"),key])
        if name!=None:
            if fmtsetdict.has_key(name):
                self.cfmtset.set_active_iter(fmtsetdict[name])
    def on_CConFmt_changed(self,a="",b="",c=""):
        fmtinfo.data["Container"]=confmt_store.get_value(self.cconfmt.get_active_iter(),1)
        self.econcmd.set_text(fmtinfo.container.getcmd())
    def on_CVideoCodec_changed(self,a="",b="",c=""):
        fmtinfo.data["videocodec"]=videocodec_store.get_value(self.cvideocodec.get_active_iter(),1)
        self.evideocmd.set_text(fmtinfo.video.getcmd())
    def on_EFps_changed(self,a="",b="",c=""):
        fmtinfo.data["fps"]=self.efps.get_text()
        self.efpscmd.set_text("-ofps "+fmtinfo.data["fps"])
    def on_CAudioCodec_changed(self,a="",b="",c=""):
        fmtinfo.data["audiocodec"]=audiocodec_store.get_value(self.caudiocodec.get_active_iter(),1)
        self.eaudiocmd.set_text(fmtinfo.audio.getcmd())
    def on_CFmtSet_changed(self,a="",b="",c=""):
        if self.cfmtset.get_active_iter()==None:
            return
        fmtinfo.data=formatlist.list[fmtset_store.get_value(self.cfmtset.get_active_iter(),1)]
        self.refresh()
    def on_EOtherCmd_changed(self,a=None,b=None,c=None):
        fmtinfo.data["other"]=self.eothercmd.get_text()
    def close(self,a="",b="",c=""):
        self.win.hide()
        mainwin.refresh()
        fmt_store.clear()
        customfmtiter=fmt_store.append([_("CustomFormat"),"CustomFormat"])
        for key in formatlist.list:
            fmt_store.append([key,key])
        return True
    def setao(self,a="",b="",c=""):
        if ao.has_key(AudioList.data[fmtinfo.data["audiocodec"]]["type"]):
            ao[AudioList.data[fmtinfo.data["audiocodec"]]["type"]].setup()
            self.eaudiocmd.set_text(fmtinfo.audio.getcmd())
    def setvo(self,a="",b="",c=""):
        if vo.has_key(VideoList.data[fmtinfo.data["videocodec"]]["type"]):
            vo[VideoList.data[fmtinfo.data["videocodec"]]["type"]].setup()
            self.evideocmd.set_text(fmtinfo.video.getcmd())

    def savefmt(self,a=None,b=None,c=None):
        _fmtiter=self.cfmtset.get_active_iter()
        if _fmtiter!=None:
            _fmtname=fmtset_store.get_value(self.cfmtset.get_active_iter(),1)
        else:
            _fmtname=""
        text=input_text_dialog(_("Save:"),_("Save:"),_("Enter Format Name:"),_fmtname)
        if text!=None:
            formatlist.save(text,fmtinfo.data)
            self.fmtset_refresh(text)
    def delfmt(self,a=None,b=None,c=None):
        formatlist.delete(fmtset_store.get_value(self.cfmtset.get_active_iter(),1))
        self.fmtset_refresh()


def convertfeedback(win,infiles,outpath,outfilename,cmds):
    i=0
    filescount=len(infiles)
    outpath=filecode(outpath)
    win.toutput.get_buffer().set_text("")
    for infile in infiles:
        i+=1
        filesstr=str(i)+"/"+str(filescount)+" "
        infile=infile.strip()
        if infile[0]=='"' and infile[-1]=='"':
            infile=infile[1:-1].replace('\\"','"')
        if outfilename=="" or filescount>1:
            outfilename=autogenoutfile(infile,fmtinfo.data)
        outfile=filecode(outfilename)
        cmd=[mencoder_path+preferences["mencoder"]["mencodercmd"]]+cmds+["-msglevel","all=1:statusline=5"]+subtitlecmd(infile)+[filecode(infile),"-o",outpath+os.sep+outfile]
        print cmd
        if win.stop:
            break
        win.pipe= runmencoder(cmd)
        win.ppercent.set_fraction(0)
        printfb(_("converting %U.....\n\n").replace("%U",infile))
        while win.pipe.poll()==None:
                feedback=win.pipe.stdout.readline()
                #win.pipe.stdout.flush()
                win.setpercent(feedback,filesstr,outpath+os.sep+outfile,outfilename)
        win.ppercent.set_fraction(1)
        feedback=win.pipe.stderr.read()
        if feedback !="":
            printfb(_("Error code:\n")+feedback)
        if win.pipe.returncode:
            printfb(infile+_(" convert error."))
        else:
            printfb(infile+_(" convert finfish."))
    win.ppercent.set_text(_("Finished"))
def printfb(str):
    buffer=outputwin.toutput.get_buffer()
    buffer.set_text(buffer.get_text(buffer.get_start_iter(),buffer.get_end_iter())+"\n"+str)
def autogenoutfile(infile,data):
    name=os.path.splitext(os.path.basename(infile))[0]+"-"
    if data["changesize"]:
        name+=data["width"]+"X"+data["height"]
    name+=os.extsep
    name+=ContainerList.data[data["Container"]]["type"]
    return name

outputre=re.compile(r"Pos:[\s]*([\d]+\.[\d])+s[\s]*[\d]+f[\s]*\([\s]*([\d]+)%\).*Trem:[\s]*([\d]+)[^\d]*([\d]+)")

class OutputWin:
    def __init__(self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"OutputWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('OutputWin')
        self.toutput= xml.get_widget('TOutput')
        self.ppercent= xml.get_widget('PPercent')
       
    def run(self,infile,outpath,outfile,cmd):
        self.win.show()
        self.stop=False
        self.starttime=0.0
        if fmtinfo.data["starttime"]["enable"]:
            _match=re.compile(r"(?:([\d]{1,2}):){0,1}?(?:([\d]{1,2}):)?([\d]+)(\.[\d]{1,2})?$").match(fmtinfo.data["starttime"]["value"])
            if _match != None:
                self.starttime=float(_match.group(3))
                if _match.group(1)!=None:
                    self.starttime+=float(_match.group(1))*3600
                if _match.group(2)!=None:
                    self.starttime+=float(_match.group(2))*60
                if _match.group(4)!=None:
                    self.starttime+=float(_match.group(4))
        self.endtime=0.0
        self.endbyte=0.0
        if fmtinfo.data["endtime"]["enable"]:
            _match=re.compile(r"(?:([\d]{1,2}):)??(?:([\d]{1,2}):)?([\d]+)(\.[\d]{1,2})?$").match(fmtinfo.data["endtime"]["value"])
            if _match != None:
                self.endtime=float(_match.group(3))
                if _match.group(1)!=None:
                    self.endtime+=float(_match.group(1))*3600
                if _match.group(2)!=None:
                    self.endtime+=float(_match.group(2))*60
                if _match.group(4)!=None:
                    self.endtime+=float(_match.group(4))
            else:
                _match=re.compile(r"([\d]+)(MB|KB|B)").match(fmtinfo.data["endtime"]["value"].upper())
                if _match !=None:
                    if _match.group(2)=="MB":
                        _bytes=1048576.0
                    else:
                        if _match.group(2)=="KB":
                            _bytes=1024.0
                        else:
                            _bytes=1.0
                self.endbyte=int(_match.group(1))*_bytes
        if re.compile(r'((["]([^"]|\\")*["])[\s]+)+$').match(infile+" ")==None:
            infile=[infile]
        else:
            infile=re.compile(r'["](?:(?:[^"]|\\")*)["][\s]+').findall(infile+" ")
        cmds=re.compile(r'\S+').findall(cmd)
        self.thread=thread.start_new_thread(convertfeedback,(self,infile,outpath,outfile,cmds))
    def setpercent(self,output,filestr,outfile,outfilebasename):
        if output=="":
            return
        if output[:4]=="Pos:":
            _match=outputre.match(output)
            if _match !=None:
                if _match.group(2)=="0" and _match.group(3)=="0" and _match.group(4)=="0":
                    self.ppercent.set_text(filestr+_(" : Unkown"))
                    self.ppercent.set_fraction(0)
                    return
                _pos=float(_match.group(1))
                _precent=int(_match.group(2))
                if self.endtime != 0:
                    _precent=max(int(((_pos)/self.endtime)*100),_precent)
                else:
                    if self.endbyte !=0:
                        _precent=max(int((os.stat(outfile).st_size/self.endbyte)*100),_precent)
                _precent=min(99,_precent)
                self.ppercent.set_text(outfilebasename+"   "+filestr+" : "+str(_precent)+"%")
                self.ppercent.set_fraction(_precent/100.0)
            else:
                printfb(output)
    def close(self,a=None,b=None,c=None):
        self.stop=True
        if self.pipe.poll()==None:
            pkill(self.pipe)
        self.win.hide()
        return True

def subtitlecmd(infile):
    cmd=[]
    if preferences["subtitle"]["usesub"].upper() == "TRUE":
        for item in subtitlelist:
            if os.path.exists(os.path.splitext(infile)[0]+os.extsep+item):
                cmd=["-sub",filecode(os.path.splitext(infile)[0]+os.extsep+item),"-subcp",preferences["subtitle"]["charset"]]
                if os.path.exists("fontconfig"):
                    cmd+=["-fontconfig","-font"]
                    if preferences["subtitle"]["usefont"].upper()=="TRUE":
                        cmd+=['"'+preferences["subtitle"]["font"]+'"']
                    else:
                        cmd+=["system"]
    return cmd
     

class PreferencesWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"PreferencesWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win = xml.get_widget('PreferencesWin')
        self.cusesub = xml.get_widget('CUseSub')
        self.tsub = xml.get_widget('TSub')
        self.echarset = xml.get_widget('ECharset')
        self.cusefont = xml.get_widget('CUseFont')
        self.fbfont = xml.get_widget('FBFont')
        self.emencodercmd = xml.get_widget('EMencoderCmd')
        self.eparameters = xml.get_widget('EParameters')
        self.data={}
    def refresh(self):
        if  self.data["subtitle"]["usesub"].upper()=="TRUE":
            self.cusesub.set_active(True)
            self.tsub.show()
        else:
            self.cusesub.set_active(False)
            self.tsub.hide()
        if self.data["subtitle"]["usefont"].upper()=="TRUE":
            self.cusefont.set_active(True)
            self.fbfont.show()
        else:
            self.cusefont.set_active(False)
            self.fbfont.hide()
        self.echarset.set_text(self.data["subtitle"]["charset"])
        self.eparameters.set_text(self.data["mencoder"]["parameters"])
        self.emencodercmd.set_text(self.data["mencoder"]["mencodercmd"])
        self.fbfont.set_font_name(self.data["subtitle"]["font"])
    def go(self):
        self.data=dict(preferences)
        self.refresh()
        response=self.win.run()
        if response==gtk.RESPONSE_OK:
            if self.cusesub.get_active():
                preferences["subtitle"]["usesub"]="TRUE"
            else:
                preferences["subtitle"]["usesub"]="FALSE"
            preferences["subtitle"]["charset"]=self.echarset.get_text()
            preferences["subtitle"]["font"]=self.fbfont.get_font_name()[:self.fbfont.get_font_name().rfind(" ")+1]
            if self.cusefont.get_active():
                preferences["subtitle"]["usefont"]="TRUE"
            else:
                preferences["subtitle"]["usefont"]="FALSE"
            preferences["mencoder"]["mencodercmd"]=self.emencodercmd.get_text()
            preferences["mencoder"]["parameters"]=self.eparameters.get_text()
            saveconfig(preferences)
        self.win.hide()
    def close(self,b=None,c=None):
        self.win.response(gtk.RESPONSE_CANCEL)
        return True
    def ok(self,dialog):
        self.win.response(gtk.RESPONSE_OK)
    def toggleusefont(self,a=None,b=None,c=None):
        if self.cusefont.get_active():
            self.fbfont.show()
        else:
            self.fbfont.hide()
    def toggleusesub(self,a=None,b=None,c=None):
        if self.cusesub.get_active():
            self.tsub.show()
        else:
            self.tsub.hide()

class AboutWin:
    def __init__(self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"AboutWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win = xml.get_widget('AboutWin')
    def close(self,a="",b="",c=""):
        self.win.response(gtk.RESPONSE_CANCEL)
        return True

mainwin=MainWin()
setwin=SetWin()
outputwin=OutputWin()
preferenceswin=PreferencesWin()
aboutwin=AboutWin()        

    
